; ///////////////////////////////
; // Love Stung
; // version 1.0
; // by Eikon (eikon@eiksoft.com)
; ///////////////////////////////
AppTitle "Love Stung"
CallDLL "bin/seticon.dll", "SetIconLg"
CallDLL "bin/retro.dll", "SetWinPosFull"
Graphics 512, 228, 16, 3
SetBuffer BackBuffer()
SeedRnd MilliSecs()
HidePointer 

Include "lib/bbasc.bb" ; Include BBASCII Library

Type Obj 
	Field X#, Y#, CF, CB, Char, ID, A, R
End Type

Global imgBack = LoadAnimImage("back.png", 512, 228, 0, 2)
Global bSound = True

.Again
RenderTitle

Global pX = 16, pY# = 192, pG# = 0, pJump = False
Global pLife = 5, pScore = 0, pCol, pFall, pFlowers = 0, flowerTotal = 5, pAmmo = 10
Global enemyTime = MilliSecs(), enemyLimit = 5000

GenerateFlowers

GameTime = CreateTimer(90)
While Not KeyDown(1)

DrawImage imgBack, 0, 0, 1
DrawImage imgBack, 0, 0, 0

AscChar 128, 120, 14, 6, 15 ; Bee hive
AscChar 360, 96, 16, 0, 1   ; Fair Maiden

RenderObj                   ; Objects

AscChar pX, pY, 14, 0, 2    ; Player

AscText 49, 17, 15, 0, "Flowers: " + pFlowers + "/" + flowerTotal
AscText 49, 18, 15, 0, "  Score: " + pScore
AscText 1, 2, 15, 0, "Arrows: " + pAmmo

;Color 255, 255, 255
;Text 1, 40, pX + ", " + pY

tmpX = 10
For i = 1 To pLife
	AscChar tmpX, 8, 16, 0, 3
	tmpX = tmpX + 10
Next

RenderCross

If KeyDown(203) Or KeyDown(30) And pCol <> 0 And pX > 0 Then pX = pX - 1
If KeyDown(205) Or KeyDown(32) And pCol <> 1 And pX < 504 Then pX = pX + 1
If (KeyDown(57) Or MouseDown(2)) And (pJump = False And pFall = False) Then ; Jump
	pG = -2
	pJump = True
EndIf

If MouseHit(1) And pAmmo > 0 Then ; Shoot
	pAmmo = pAmmo - 1
	o.Obj = New Obj
	o\X = pX + 4: o\Y = pY + 6
	o\R = 0: o\A = ATan2(MouseY() - (PY + 6), MouseX() - (PX + 4))
	o\ID = 2
	If bSound = True Then CallDLL "bin/retro.dll", "Beep6"
EndIf

; Feet collision
If ImageRectCollide(imgBack, 0, 0, 0, pX, pY + 12, 8, 1) Then ; Land
	pFall = False
	If pJump = True And pG > 0 Then pJump = False
	tmpRise = 1
	For i = pY + 11 To pY + 8 Step -1 ; Riser
		If ImageRectCollide(imgBack, 0, 0, 0, pX, i, 8, 1) Then pY = pY - tmpRise: Exit
		tmpRise = tmpRise + 1
	Next
Else ; Fall
	pFall = True
	If pJump = False Then pY = pY + 2
EndIf

; Left/Right collision
pCol = -1
If ImageRectCollide(imgBack, 0, 0, 0, pX + 8, pY, 2, 10) Then pCol = 1 ; Right blocked
If ImageRectCollide(imgBack, 0, 0, 0, pX - 2, pY, 2, 10) Then pCol = 0     ; Left blocked
; Head collision
If ImageRectCollide(imgBack, 0, 0, 0, pX, pY, 1, 8) And pJump = True And pG < 0 Then pG = 1 

If pJump = True Then
	pY = pY + pG
	If pG < 2 Then pG = pG + .1 Else pG = 2
	If (KeyDown(57) Or MouseDown(2)) And pG < 0 Then pG = pG - .06
EndIf

If RectsOverlap(pX, pY, 8, 12, 360, 96, 8, 12) And pFlowers = FlowerTotal Then
	If bSound = True Then CallDLL "bin/retro.dll", "Beep4"
	pFlowers = 0
	pScore = pScore + (100 * FlowerTotal)
	If flowerTotal < 30 Then flowerTotal = flowerTotal + 1
	If enemyLimit > 4500 And enemyLimit <= 5000 Then
		pAmmo = pAmmo + 6
	ElseIf enemyLimit > 4000 And enemyLimit <= 4500 Then
		pAmmo = pAmmo + 7
	ElseIf enemyLimit > 3500 And enemyLimit <= 4000 Then
		pAmmo = pAmmo + 9
	ElseIf enemyLimit >= 2000 And enemyLimit <= 3500 Then
		pAmmo = pAmmo + 10
	EndIf
	If enemyLimit > 2000 Then enemyLimit = enemyLimit - 200 Else enemyLimit = 2000
	GenerateFlowers
EndIf

If MilliSecs() >= enemyTime + enemyLimit Then ; Bee Time
	o.Obj = New Obj
	o\X = 128: o\Y = 120: o\CF = 14: o\CB = 0: o\Char = 237: o\ID = 3
	o\A = Rand(0, 1)
	
	enemyTime = MilliSecs()
EndIf

If pLife <= 0 Then GameOver: Goto Again

;Color 255, 0, 0
;Rect pX, pY + 10, 8, 1

WaitTimer GameTime
Flip 0: Cls
Wend
Goto Again

Function RenderTitle()
FlushKeys
Delete Each Obj

Repeat
Cls
	AscText 3, 1, 15, 0, "Love Stung"
	AscChar 7, 12, 16, 0, 3
	AscChar 112, 12, 16, 0, 3
	
	AscText 3, 3, 15, 0, "As a royal knight in the Queen's army, you must prove your"
	AscText 3, 4, 15, 0, "love to the fair maiden Penelope on Valentine's day. Your" 
	AscText 3, 5, 15, 0, "mission is to collect as many flowers as possible, then" 
	AscText 3, 6, 15, 0, "to deliver them to Penelope." 

	AscText 3, 8, 15, 0, "Beware of the evil bees that come from a hive on the tree"
	AscText 3, 9, 15, 0, "of despair. Even with your armor, you may only sustain 5"
	AscText 3, 10, 15, 0, "stings before subcoming to their deadly poison."
	
	AscText 3, 12, 16, 0, "Controls"
	AscText 3, 13, 15, 0, "ASDW / Cursor keys for movement"
	AscText 3, 14, 15, 0, "Space / Mouse Button 2 to jump"
	AscText 3, 15, 15, 0, "Mouse Button 1 to fire an arrow"

	AscText 3, 17, 16, 0, "Press ENTER to play"
	AscText 40, 17, 15, 0, "F1) PC Speaker Sound: " + bSound
	
	If KeyHit(59) Then 
		If bSound < 1 Then bSound = bSound + 1 Else bSound = 0
	EndIf
	
	If KeyHit(1) Then End
Flip
Until KeyHit(28)
FlushKeys

End Function

Function GameOver()

FlushKeys
Repeat
Cls

AscText 1, 1, 15, 0, "You died from multiple bee stings to the head"
AscText 1, 2, 15, 0, "Final Score: " + pScore
AscText 1, 4, 14, 0, "Press ENTER to continue"

Flip
Until KeyHit(28)
FlushKeys
Delete Each Obj
End Function

Function RenderCross()

Color 255, 255, 255
Line MouseX() - 3, MouseY(), MouseX() + 3, MouseY()
Line MouseX(), MouseY() - 2, MouseX(), MouseY() + 2
Color 0, 0, 0: Rect MouseX(), MouseY(), 1, 1

End Function

Function GenerateFlowers()

For i = 0 To FlowerTotal - 1
o.Obj = New Obj
tmpR = Rand(0, 5)
If tmpR = 0 Then ; Area 1
	o\Y = 180
	o\X = Rand(113, 192) 
ElseIf tmpR = 1 Then ; Area 2
	o\Y = 204
	o\X = Rand(225, 263)
ElseIf tmpR = 2 Then ; Area 3
	o\Y = 168
	o\X = Rand(337, 439)
ElseIf tmpR = 3 Then ; Area 4
	o\Y = 192
	o\X = Rand(272, 303)
ElseIf tmpR = 4 Then ; Area 5
	o\Y = 203
	o\X = Rand(57, 79)	
ElseIf tmpR = 5 Then ; Area 6
	o\Y = 192
	o\X = Rand(16, 48)	
EndIf
	
tmpR = Rand(0, 3)
If tmpR = 0 Then o\CF = 11 ; Blue
If tmpR = 1 Then o\CF = 12 ; Red
If tmpR = 2 Then o\CF = 16 ; Pink
If tmpR = 3 Then o\CF = 14 ; Yellow
o\CB = 0
tmpR = Rand(0, 2)
If tmpR = 0 Then o\Char = 5
If tmpR = 1 Then o\Char = 6
If tmpR = 2 Then o\Char = 231
o\ID = 1
Next

End Function

Function RenderObj()

Local Del

For o.Obj = Each Obj
	Del = False
	Select o\ID
		Case 1 ; Flowers
		AscChar o\X, o\Y, o\CF, o\CB, o\Char
		
		If RectsOverlap(pX, pY, 8, 12, o\X, o\Y, 8, 12) Then 
			tmpR = Rand(1, 3)
			If bSound = True Then CallDLL "bin/retro.dll", "Beep" + Str(tmpR)
			Del = True: pFlowers = pFlowers + 1
		EndIf
		
		Case 2 ; Bullet
		Color 255, 255, 255: Line o\R * Cos(o\A) + o\X, o\R * Sin(o\A) + o\Y, (o\R - 4) * Cos(o\A) + o\X, (o\R - 4) * Sin(o\A) + o\Y
		o\R = o\R + 2
		
		tmpX = o\R * Cos(o\A) + o\X
		tmpY = o\R * Sin(o\A) + o\Y
		If ImageRectCollide(imgBack, 0, 0, 0, tmpX, tmpY, 2, 2) Then Del = True
		If tmpX <= 0 Or tmpY >= 512 Or tmpY <= 0 Or tmpY >= 228 Then Del = True
		
		Case 3 ; Bee
		AscChar o\X, o\Y, o\CF, o\CB, o\Char
		If o\A = 1 Then ; Follow
			If o\X < pX Then o\X = o\X + Rnd(.1, 1)
			If o\X > pX Then o\X = o\X - Rnd(.1, 1)
			If o\y < pY Then o\Y = o\Y + Rnd(.1, 1)
			If o\Y > pY Then o\Y = o\Y - Rnd(.1, 1)
		Else
			o\X = o\X + Rnd(-.5, .5)
			o\Y = o\Y + Rnd(-.5, .5)			
		EndIf
		
		If Rand(1, 100) = 50 Then
			If o\A = 0 Then o\A = 1 Else o\A = 0
		EndIf
			
		If RectsOverlap(o\X, o\Y, 8, 12, pX, pY, 8, 12) Then 
			pLife = pLife - 1
			If bSound = True Then CallDLL "bin/retro.dll", "Beep5"
			Del = True
		EndIf
		
		If Del = False Then
		If CheckBulletCollision(o\X, o\Y) = True Then 
			If bSound = True Then CallDLL "bin/retro.dll", "Beep5"
			Del = True
			pScore = pScore + 100
		EndIf
		EndIf
		
	End Select
	If Del = True Then Delete o
Next

End Function


Function CheckBulletCollision(X, Y)

For o.Obj = Each Obj
	If o\ID = 2 Then
		If RectsOverlap(o\R * Cos(o\A) + o\X, o\R * Sin(o\A) + o\Y, 2, 2, X, Y, 8, 12) Then Delete o: Return True
	EndIf
Next

Return False

End Function